#!/usr/bin/perl -w

# This glossary was made by the ACTS Corporation
# Website: http://www.actscorp.com
# Email: glossary@actscorp.com
#
# Porting made by Rene J. Valdez
# Website: http://www.geocities.com/necho8
# Email: necho8@yahoo.com
#
# Creation Date: September, 8, 2000

# You must specify the full path of the tech.gls file here
# The script will not function *doh* without this file.

my $glossary_location = "/home/necho8/xchat_scripts/";

#######################################################

IRC::register ("Techinical Awareness Glossary", "7.0", "", "");
IRC::print "\0035:: Loading Technical Awareness Glossary ::\0035\n";
IRC::add_message_handler("PRIVMSG", "parse_msg");

sub parse_msg {
	my $channel = IRC::get_info(2);
	my $data = shift(@_);
	$data =~ /:(.*?)!(.*@.*) .*:(.*)/;
	my $nick = $1;
	my $msg = $3; 

        if($msg =~ /.*what\s+(is|are)\s+(a|the|an)\s+(.+)/i) {
		&display_data($channel, $nick, $3);
        }
	elsif($msg =~ /.*(what|who)\s+is\s+(.+)/i) {
        	&display_data($channel, $nick, $2);
	}

}

sub display_data {
	my($channel, $nick, $query) = @_;
	my($count, $current, $results);
	$query =~ s/[^\s\w]+//g;
	open(GLOSSARY, "$glossary_location/tech.gls") or 
	IRC::print "\0035 Could not open tech.gls \0035\n";
	IRC::print "\0035 Finding out what $query means \0035\n";
	while (defined($line = <GLOSSARY>)) {
		if($line =~ /<TERM COUNT="(.+)">$query<\/TERM>/i) {
			$count = $1;
			next;
		}
		if($line =~ /<TERM COUNT="(.*)">.*<\/TERM>/i) {
			$current = $1;
		}
		next if ! defined($count);
		$results.= $line unless $count < $current;
	}
	if(length($results) > 0) {
		$results =~ s/[^\S][\W]//g;
		IRC::send_raw "PRIVMSG $channel :$nick: $query - $results\n"; 
	}
	else {
		IRC::print "\0035 Couldn't find a result for $query. \0035\n";
	}
}
